summaryrefslogtreecommitdiff
path: root/herbstluftwm/autostart
diff options
context:
space:
mode:
authorzachir <zachir@librem.one>2022-10-05 22:00:32 -0500
committerzachir <zachir@librem.one>2022-10-05 22:00:32 -0500
commitf39d735e2ba625a31a7dbf6fb8bdd62501379ad1 (patch)
treed17c96714c930e0b8bc75616cc9c81b961ed5aa0 /herbstluftwm/autostart
Initial Commit
Diffstat (limited to 'herbstluftwm/autostart')
-rwxr-xr-xherbstluftwm/autostart205
1 files changed, 205 insertions, 0 deletions
diff --git a/herbstluftwm/autostart b/herbstluftwm/autostart
new file mode 100755
index 0000000..3f53457
--- /dev/null
+++ b/herbstluftwm/autostart
@@ -0,0 +1,205 @@
+#!/usr/bin/bash
+
+# this is a simple config for herbstluftwm
+
+hc() {
+ herbstclient "$@"
+}
+
+if [ -n "$XDG_CONFIG_HOME" ]; then
+ $XDG_CONFIG_HOME/X11/xprofile &
+ $XDG_CONFIG_HOME/autostart.sh &
+else
+ $HOME/.config/X11/xprofile &
+ $HOME/.config/autostart.sh &
+fi
+
+launch_polybar.sh herbstluft
+
+hc emit_hook reload
+
+# remove all existing keybindings
+hc keyunbind --all
+
+hc pad 0 20
+
+hc detect_monitors
+
+# keybindings
+# if you have a super key you will be much happier with Mod set to Mod4
+Mod=Mod1 # Use alt as the main modifier
+#Mod=Mod4 # Use the super key as the main modifier
+TERMINAL=st
+
+hc keybind $Mod-Shift-e quit
+hc keybind $Mod-Shift-r reload
+hc keybind $Mod-Shift-q close
+hc keybind $Mod-Return spawn $TERMINAL
+hc keybind $Mod-Shift-Return spawn $TERMINAL
+#hc keybind Super-l spawn i3lock-fancy
+#hc keybind $Mod-m spawn mpcalbum.sh
+#hc keybind $Mod-Shift-m spawn mpvlist.sh
+
+# scratchpads
+hc keybind $Mod+Control+z spawn ~/.config/herbstluftwm/sphtop
+hc keybind $Mod+Control+x spawn ~/.config/herbstluftwm/spterm
+hc keybind $Mod+Control+c spawn ~/.config/herbstluftwm/sppmxr
+hc keybind $Mod+Control+v spawn ~/.config/herbstluftwm/spblue
+hc keybind $Mod+Control+b spawn ~/.config/herbstluftwm/spncmp
+hc keybind $Mod+Control+a spawn ~/.config/herbstluftwm/spmutt
+hc keybind $Mod+Control+s spawn ~/.config/herbstluftwm/spprof
+hc keybind $Mod+Control+d spawn ~/.config/herbstluftwm/spirss
+#hc keybind $Mod+Control+f spawn ~/.config/herbstluftwm/spmpv
+
+# minimize and unminimize
+hc keybind $Mod+n jumpto last-minimized
+hc keybind $Mod+Shift+n set_attr clients.focus.minimized toggle
+
+# basic movement
+# focusing clients
+hc keybind $Mod-h focus left
+hc keybind $Mod-j focus down
+hc keybind $Mod-k focus up
+hc keybind $Mod-l focus right
+
+# moving clients
+hc keybind $Mod-Shift-h shift left
+hc keybind $Mod-Shift-j shift down
+hc keybind $Mod-Shift-k shift up
+hc keybind $Mod-Shift-l shift right
+
+# splitting frames
+# create an empty frame at the specified direction
+hc keybind $Mod-u split bottom 0.5
+hc keybind $Mod-o split right 0.5
+# let the current frame explode into subframes
+hc keybind $Mod-Control-space split explode
+
+# resizing frames
+resizestep=0.05
+hc keybind $Mod-Control-h resize left +$resizestep
+hc keybind $Mod-Control-j resize down +$resizestep
+hc keybind $Mod-Control-k resize up +$resizestep
+hc keybind $Mod-Control-l resize right +$resizestep
+hc keybind $Mod-Control-Left resize left +$resizestep
+hc keybind $Mod-Control-Down resize down +$resizestep
+hc keybind $Mod-Control-Up resize up +$resizestep
+hc keybind $Mod-Control-Right resize right +$resizestep
+
+# tags
+tag_names=( {1..9} )
+tag_keys=( {1..9} 0 )
+
+hc rename default "${tag_names[0]}" || true
+for i in ${!tag_names[@]} ; do
+ hc add "${tag_names[$i]}"
+ key="${tag_keys[$i]}"
+ if ! [ -z "$key" ] ; then
+ hc keybind "$Mod-$key" spawn hwinmv use_index $i
+ hc keybind "$Mod-Shift-$key" spawn hwinmv move_index "$i"
+ fi
+done
+
+# cycle through tags
+hc keybind $Mod-period use_index +1 --skip-visible
+hc keybind $Mod-comma use_index -1 --skip-visible
+
+# layouting
+hc keybind $Mod-e remove
+hc keybind $Mod-Shift-f floating toggle
+hc keybind $Mod-f fullscreen toggle
+# The following cycles through the available layouts within a frame, but skips
+# layouts, if the layout change wouldn't affect the actual window positions.
+# I.e. if there are two windows within a frame, the grid layout is skipped.
+hc keybind $Mod-space \
+ or , and . compare tags.focus.curframe_wcount = 2 \
+ . cycle_layout +1 vertical horizontal max vertical grid \
+ , cycle_layout +1
+
+# mouse
+hc mouseunbind --all
+hc mousebind $Mod-Button1 move
+hc mousebind $Mod-Button2 zoom
+hc mousebind $Mod-Button3 resize
+
+# focus
+hc keybind $Mod-BackSpace cycle_monitor
+hc keybind $Mod-Tab cycle_all +1
+hc keybind $Mod-Shift-Tab cycle_all -1
+hc keybind $Mod-c cycle
+hc keybind $Mod-i jumpto urgent
+
+# theme
+hc attr theme.tiling.reset 1
+hc attr theme.floating.reset 1
+hc set frame_border_active_color '#222222'
+hc set frame_border_normal_color '#101010'
+hc set frame_bg_normal_color '#565656'
+hc set frame_bg_active_color '#345F0C'
+hc set frame_border_width 1
+hc set always_show_frame 1
+hc set frame_bg_transparent 1
+hc set frame_transparent_width 5
+hc set frame_gap 4
+hc set hide_covered_windows on
+
+hc attr theme.active.color '#9fbc00'
+hc attr theme.normal.color '#454545'
+hc attr theme.urgent.color orange
+hc attr theme.inner_width 1
+hc attr theme.inner_color black
+hc attr theme.border_width 3
+hc attr theme.floating.border_width 4
+hc attr theme.floating.outer_width 1
+hc attr theme.floating.outer_color black
+hc attr theme.active.inner_color '#3E4A00'
+hc attr theme.active.outer_color '#3E4A00'
+hc attr theme.background_color '#141414'
+
+hc set window_gap 0
+hc set frame_padding 0
+hc set smart_window_surroundings 0
+hc set smart_frame_surroundings 1
+hc set mouse_recenter_gap 0
+hc set focus_follows_mouse 1
+
+# rules
+hc unrule -F
+#hc rule class=XTerm tag=3 # move all xterms to tag 3
+hc rule focus=on # normally focus new clients
+#hc rule focus=off # normally do not focus new clients
+# give focus to most common terminals
+#hc rule class~'(.*[Rr]xvt.*|.*[Tt]erm|Konsole)' focus=on
+hc rule windowtype~'_NET_WM_WINDOW_TYPE_(DIALOG|UTILITY|SPLASH)' pseudotile=on
+hc rule windowtype='_NET_WM_WINDOW_TYPE_DIALOG' focus=on
+hc rule windowtype~'_NET_WM_WINDOW_TYPE_(NOTIFICATION|DOCK|DESKTOP)' manage=off
+# scratchpad rules
+hc rule instance=sphtop floatplacement=center floating=true floating_geometry=900x600
+hc rule instance=spterm floatplacement=center floating=true floating_geometry=900x600
+hc rule instance=sppmxr floatplacement=center floating=true floating_geometry=900x600
+hc rule instance=spblue floatplacement=center floating=true floating_geometry=900x600
+hc rule instance=spncmp floatplacement=center floating=true floating_geometry=900x600
+hc rule instance=spmutt floatplacement=center floating=true floating_geometry=900x600
+hc rule class=spprof floatplacement=center floating=true floating_geometry=900x600
+hc rule class=spirss floatplacement=center floating=true floating_geometry=900x600
+#hc rule class=mpv floatplacement=center floating=true floating_geometry=900x600
+
+hc set tree_style '╾│ ├└╼─┐'
+
+# unlock, just to be sure
+hc unlock
+
+# do multi monitor setup here, e.g.:
+# hc set_monitors 1280x1024+0+0 1280x1024+1280+0
+# or simply:
+# hc detect_monitors
+
+# find the panel
+#panel=~/.config/herbstluftwm/backup_panel.sh
+#[ -x "$panel" ] || panel=/etc/xdg/herbstluftwm/panel.sh
+#for monitor in $(herbstclient list_monitors | cut -d: -f1) ; do
+# # start it on each monitor
+# "$panel" $monitor &
+#done
+
+sh tagmv 0